/***************************************************************************
 *                                                                         *
 *  MAXIMUS-CBCS Source Code, Version 1.02                                 *
 *  Copyright 1989, 1990 by Scott J. Dudley.  All rights reserved.         *
 *                                                                         *
 *  Replacement for BoreLand's (heh) fnsplit() function                    *
 *                                                                         *
 *  For complete details of the licensing restrictions, please refer to    *
 *  the licence agreement, which is published in its entirety in MAX.C     *
 *  and LICENCE.MAX.                                                       *
 *                                                                         *
 *  USE OF THIS FILE IS SUBJECT TO THE RESTRICTIONS CONTAINED IN THE       *
 *  MAXIMUS-CBCS LICENSING AGREEMENT.  IF YOU DO NOT FIND THE TEXT OF THIS *
 *  AGREEMENT IN ANY OF THE  AFOREMENTIONED FILES, OR IF YOU DO NOT HAVE   *
 *  THESE FILES, YOU SHOULD IMMEDIATELY CONTACT THE AUTHOR AT ONE OF THE   *
 *  ADDRESSES LISTED BELOW.  IN NO EVENT SHOULD YOU PROCEED TO USE THIS    *
 *  FILE WITHOUT HAVING ACCEPTED THE TERMS OF THE MAXIMUS-CBCS LICENSING   *
 *  AGREEMENT, OR SUCH OTHER AGREEMENT AS YOU ARE ABLE TO REACH WITH THE   *
 *  AUTHOR.                                                                *
 *                                                                         *
 *  You can contact the author at one of the address listed below:         *
 *                                                                         *
 *  Scott Dudley           FidoNet  1:249/106                              *
 *  777 Downing St.        IMEXnet  89:483/202                             *
 *  Kingston, Ont.         Internet f106.n249.z1.fidonet.org               *
 *  Canada - K7M 5N3       BBS      (613) 389-8315 - HST/14.4K, 24hrs      *
 *                                                                         *
 ***************************************************************************/

#ifndef __TURBOC__
#error Dummy, this module is for Turbo C only!
#endif

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "prog.h"
#include "dr.h"

#ifndef __TURBOC__

#define WILDCARDS   0x01
#define EXTENSION   0x02
#define FILENAME    0x04
#define DIRECTORY   0x08
#define DRIVE       0x10

#endif

#ifdef __MSC__
#define MAXPATH _MAX_PATH
#endif

int cdecl fnsplit(const char *path,char *drive,char *dir,char *name,char *ext)
{
  int flag=FILENAME,
      x;

  char temp[MAXPATH],
       *s;

  if (strchr(path,':'))
  {
    if (drive)
    {
      strncpy(drive,path,2);
      drive[2]='\0';
    }

    flag |= DRIVE;
    path += 2;
  }
  else if (drive)
    *drive='\0';

  if ((s=strrchr(path,'\\')) != NULL)
  {
    if (dir)
    {
      strncpy(dir,path,x=(s-(char *)path)+1);
      dir[x]='\0';
    }

    flag |= DIRECTORY;
    path=s+1;
  }
  else if (dir)
    *dir='\0';

  strcpy(temp,path);

  if ((s=strchr(temp,'.')) != NULL)
  {
    if (ext)
      strcpy(ext,s);

    flag |= EXTENSION;
    *s='\0';
  }
  else if (ext)
    *ext='\0';

  if (name)
    strcpy(name,temp);

  return flag;
}


